//+------------------------------------------------------------------+
//|           See description for further information!               |
//|                                                                  |
//|                                                                  |
//|  Under no circumstances are you allowed to spread this file in   |
//|    any way, be it for free or for sale, without the autor's      |
//|                        written permission!                       |
//|                                                                  |
//|  In no event will author be liable for any damages whatsoever.   |
//|                      Use at your own risk.                       |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//| info@forex.space-mailer.de                                       |
//|                                    Copyright  2009 Philipp Ling |
//|                                                                  |
//+------------------- DO NOT REMOVE THIS HEADER --------------------+


#property copyright "Philipp Ling"
#property link      ""

extern int Pipsaway=5;
extern int TP=200; // The Exact Amount Of the Pips u will get as the profit in your account
extern int SL=20; // Stop Loss amount in pips
extern int GMT_Offset=3;   //Offset between your broker time and GMT
extern int CTCBN=1; // Numbers of Candles to check Before News For determining High & Lows , when it is 1 it check 2 candles the current candle and the 1 last one
extern int SecBPO=300; // Seconds Before News Which EA Will Place Pending Orders
extern int SecBMO=60; // Seconds Before News Which EA Will Stop Modifying Orders
extern int STWAN=300; // Seconds To Wait After News to Delete Pending Orders
extern bool OCO=false; // One Cancel The Other , will cancel the other pending order if one of them is hit
extern int BEPips=5; // Pips In profit which EA will Move SL to BE+1 after that
extern int TrailingStop=5; // Trailing Stop
extern bool UseMarketOpening=False;
extern bool UseNews=True;
extern bool UseMM = True;
extern int RiskPercent=3;
extern double Lots = 0.01;
extern string TradeLog = " MI_Log";
double h,l,ho,lo,hso,lso,htp,ltp,sp;
int Magic, NDay=0, NHour=0, NMin=0, OHour=0, OMin=0;
string filename, TXT, TME;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
    return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----

//----
   return(0);
  }


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
   Magic=8786008;
   string mm = "No!", oco = "No!", th="th", cnt = "", NNews, Instr, fst, snd;
   int i, OrdersCondition,secofday,secofnews, UK, North_America, Japan, Europe, NTrigger = 1;
   
   if(OCO) oco = "Yes!"; 
   if(UseMM) mm = "Yes!";
   filename=Symbol() + TradeLog + "-" + Month() + "-" + Day() + ".txt";

   if (BEPips>0) DoBE(BEPips);
   
   if (TrailingStop>0) DoTrail();
   
   OrdersCondition=CheckOrdersCondition();
   
   if(!UseNews)
   {
      NTrigger = -1;
   }   
   
   Japan = 23+GMT_Offset;
   UK = 6+GMT_Offset;
   Europe = 6+GMT_Offset;
   North_America = 11+GMT_Offset;
                  
   if(Japan > 24)
   {
      Japan = Japan - 24; 
   }
   
   if(UK > 24)
   {
      UK = UK - 24; 
   }
   
   if(Europe > 24)
   {
      Europe = Europe - 24; 
   }
   
   if(North_America > 24)
   {
      North_America = North_America - 24; 
   }   
   
   if(UseMarketOpening)
   {
      if(NTrigger == -1)
      {
         if(North_America - Hour() > 0)
         {
            cnt = "North America,";
            NDay = Day();
            OHour = North_America;
            OMin = 0;

            if(Europe - Hour() > 0)
            {
               cnt = "Europe,";
               NDay = Day();
               OHour = Europe;
               OMin = 0;

               if(UK - Hour() > 0)
               {
                  cnt = "UK,";
                  NDay = Day();
                  OHour = UK;
                  OMin = 0;
                  
                  if(Japan - Hour() > 0)
                  {
                     cnt = "Japan,";
                     NDay = Day();
                     OHour = Japan;
                     OMin = 0;
                  }
               }
            }
         }
      }
      else
      {      
         if(North_America - Hour() > 0)
         {
            cnt = "North America,";
            OHour = North_America;
            OMin = 0;
            if(NHour > North_America)
            {
               NDay = Day();
               NTrigger = -1;
            }
            if(Europe - Hour() > 0)
            {
               cnt = "Europe,";
               OHour = Europe;
               OMin = 0;
               if(NHour > Europe)
               {
                  NDay = Day();
                  NTrigger = -1;
               }
               if(UK - Hour() > 0)
               {
                  cnt = "UK,";
                  OHour = UK;
                  OMin = 0;
                  if(NHour > UK)
                  {
                     NDay = Day();
                     NTrigger = -1;

                  }
                  if(Japan - Hour() > 0)
                  {
                     cnt = "Japan,";
                     OHour = Japan;
                     OMin = 0;
                     if(NHour > Japan)
                     {
                        NDay = Day();
                        NTrigger = -1;
                     }
                  }   
               }
            }
         }
      }
   }

   NNews = News_file(NTrigger);
   Instr = StringSubstr(NNews,1,3);
   fst = StringSubstr(Symbol(),0,3);
   snd = StringSubstr(Symbol(),3,3);
   if(Instr != fst && Instr != snd)
   {
      NTrigger = -1;
   }
   
   
   if(TimeMonth(TimeCurrent()) == 2 && NDay > 28)
   {
      NDay = 1;
   }
   if((TimeMonth(TimeCurrent())%2 && TimeMonth(TimeCurrent()) != 7) && NDay > 30)
   {
      NDay = 1;         
   }
   if((TimeMonth(TimeCurrent())%2 || TimeMonth(TimeCurrent()) == 8) && NDay > 31)
   {
      NDay = 1;         
   }

   secofday=Hour()*3600+Minute()*60+Seconds();
   secofnews=NHour*3600+NMin*60;
   if(NTrigger == -1)
   {
      secofnews=OHour*3600+OMin*60;
   }
   
   h=iHigh(NULL,PERIOD_M1,0);
   l=iLow(NULL,PERIOD_M1,0);
   for (i=1;i<=CTCBN;i++) if (iHigh(NULL,PERIOD_M1,i)>h) h=iHigh(NULL,PERIOD_M1,i);
   for (i=1;i<=CTCBN;i++) if (iLow(NULL,PERIOD_M1,i)<l) l=iLow(NULL,PERIOD_M1,i);
   sp=MarketInfo(Symbol(),MODE_SPREAD);
   ho=h+sp*Point+Pipsaway*Point;
   lo=l-Pipsaway*Point;
   if(SL==0)
   {
      hso = 0;
      lso = 0;
   }
   else
   {
      hso=Ask+(Pipsaway-SL)*Point;
      lso=Bid-(Pipsaway-SL)*Point;
   }
   htp=ho+TP*Point;
   ltp=lo-TP*Point;

   if(NDay==1 || NDay==21 ||NDay==31) th="st";
   if(NDay==2 || NDay==22) th="nd";
   if(NDay==3 || NDay==23) th="rd";
   
   string strg;
   int tmp;
   strg = DoubleToStr(NMin,0);
   tmp = NMin;
   string NMin;
   if(tmp < 10)
   {
      NMin = "0"+strg;
   }
   else
   {
      NMin = strg;
   }
   if(tmp == 0)
   {
      NMin = "00";
   }

   strg = DoubleToStr(OMin,0);
   tmp = OMin;
   string OMin;
   if(tmp < 10)
   {
      OMin = "0"+strg;
   }
   else
   {
      OMin = strg;
   }

   if(tmp == 0)
   {
      OMin = "00";
   }
   
   if(cnt != "Japan," && cnt != "UK," && cnt != "Europe," && cnt != "North America,")
   {
      cnt = "No other market opening today. Last";
   }
  
   if(UseNews && !UseMarketOpening)
   {
      if (Day()!=NDay)
      {
         Comment("\nNews EA (Market opening is is disabled)",
                 "\n\nHigh: ",DoubleToStr(NormalizeDouble(h,4),4)," Buy Order: ",DoubleToStr(NormalizeDouble(ho,4),4)," Stoploss: ",DoubleToStr(NormalizeDouble(hso,4),4)," TakeProfit: ",DoubleToStr(NormalizeDouble(htp,4),4),
                 "\nLow: ",DoubleToStr(NormalizeDouble(l,4),4)," Sell Order: ",DoubleToStr(NormalizeDouble(lo,4),4)," StopLoss: ",DoubleToStr(NormalizeDouble(lso,4),4)," TakeProfit: ",DoubleToStr(NormalizeDouble(ltp,4),4),
                 "\n\nNews Day: ",NDay,th,", News Time: ",NHour,":",NMin," Server Time, CTCBN: ",CTCBN,", SecBPO: ",SecBPO,", SecBMO: ",SecBMO,", STWAN: ",STWAN,", OCO: ",oco,
                 "\nBEPips: ",BEPips," Money Management: ",mm," RiskPercent: ",RiskPercent," Lots: ",LotsOptimized(Lots),
                 "\n\nExpert is disabled because it is not day of expected news",
                 "\n\nNext News coming: ",NNews,", News Time: ",NHour,":",NMin," Server Time");
                 
         return(0);
      } 
      else Comment("\nNews EA (Market opening is is disabled)",
                  "\n\nHigh: ",DoubleToStr(NormalizeDouble(h,4),4)," Buy Order: ",DoubleToStr(NormalizeDouble(ho,4),4)," Stoploss: ",DoubleToStr(NormalizeDouble(hso,4),4)," TakeProfit: ",DoubleToStr(NormalizeDouble(htp,4),4),
                  "\nLow: ",DoubleToStr(NormalizeDouble(l,4),4)," Sell Order: ",DoubleToStr(NormalizeDouble(lo,4),4)," StopLoss: ",DoubleToStr(NormalizeDouble(lso,4),4)," TakeProfit: ",DoubleToStr(NormalizeDouble(ltp,4),4),
                  "\n\nNews Day: ",NDay,th,", News Time: ",NHour,":",NMin," Server Time, CTCBN: ",CTCBN,", SecBPO: ",SecBPO,", SecBMO: ",SecBMO,", STWAN: ",STWAN,", OCO: ",oco,
                  "\nBEPips: ",BEPips,", Money Management: ",mm,", RiskPercent: ",RiskPercent,", Lots: ",LotsOptimized(Lots),
                  "\n\nNext News coming: ",NNews);
   }
   if(UseMarketOpening && !UseNews)
   {
      Comment("\nMarket opening EA (News EA is disabled)",
              "\n\nHigh: ",DoubleToStr(NormalizeDouble(h,4),4)," Buy Order: ",DoubleToStr(NormalizeDouble(ho,4),4)," Stoploss: ",DoubleToStr(NormalizeDouble(hso,4),4)," TakeProfit: ",DoubleToStr(NormalizeDouble(htp,4),4),
              "\nLow: ",DoubleToStr(NormalizeDouble(l,4),4)," Sell Order: ",DoubleToStr(NormalizeDouble(lo,4),4)," StopLoss: ",DoubleToStr(NormalizeDouble(lso,4),4)," TakeProfit: ",DoubleToStr(NormalizeDouble(ltp,4),4),
              "\n\nCTCBN: ",CTCBN,", SecBPO: ",SecBPO,", SecBMO: ",SecBMO,", STWAN: ",STWAN,", OCO: ",oco,
              "\nBEPips: ",BEPips," Money Management: ",mm," RiskPercent: ",RiskPercent," Lots: ",LotsOptimized(Lots),
              "\n\nNext market opening: ",cnt," Opening Time: ",OHour,":",OMin," Server Time");
   }
   if(UseMarketOpening && UseNews)
   {
      Comment("\nMarket opening EA and News EA are both enabled",
              "\n\nHigh: ",DoubleToStr(NormalizeDouble(h,4),4)," Buy Order: ",DoubleToStr(NormalizeDouble(ho,4),4)," Stoploss: ",DoubleToStr(NormalizeDouble(hso,4),4)," TakeProfit: ",DoubleToStr(NormalizeDouble(htp,4),4),
              "\nLow: ",DoubleToStr(NormalizeDouble(l,4),4)," Sell Order: ",DoubleToStr(NormalizeDouble(lo,4),4)," StopLoss: ",DoubleToStr(NormalizeDouble(lso,4),4)," TakeProfit: ",DoubleToStr(NormalizeDouble(ltp,4),4),
              "\n\nCTCBN: ",CTCBN,", SecBPO: ",SecBPO,", SecBMO: ",SecBMO,", STWAN: ",STWAN,", OCO: ",oco,
              "\nBEPips: ",BEPips," Money Management: ",mm," RiskPercent: ",RiskPercent," Lots: ",LotsOptimized(Lots),
              "\n\nNext News coming: ",NNews,", News Time: ",NHour,":",NMin," Server Time",
              "\nNext market opening: ",cnt," Opening Time: ",OHour,":",OMin," Server Time");  
   }
   if(!UseMarketOpening && !UseNews)
   {
      Comment("\nMarket opening EA and News EA are both disabled. No automatic trading!",
              "\n\n----------------------------------------------------------------------",
              "\n\nACCOUNT INFORMATION:",
              "\nAccount name:            ",AccountName(),
              "\nLeverage for Account # ",AccountNumber()," is ",AccountLeverage(),
              "\nAccount equity:          ",AccountEquity()," ",AccountCurrency(),
              "\nAccount balance:         ",AccountBalance()," ",AccountCurrency(),
              "\n\n----------------------------------------------------------------------",
              "\n\nBROKER INFORMATION:",
              "\nBroker Company:          ",AccountCompany(),
              "\n\n----------------------------------------------------------------------");
              
   }
   if ((secofday<secofnews) && (secofday>(secofnews-SecBPO))) {
      
      if (OrdersCondition==0) {
         Write("Opening BuyStop & SellStop, OrdersCondition="+OrdersCondition+" SecOfDay="+secofday);
         OpenBuyStop();
         OpenSellStop();
      }

      if (OrdersCondition==10) {
         Write("Opening SellStop, OrdersCondition="+OrdersCondition+" SecOfDay="+secofday);
         OpenSellStop();
      }
      
      if (OrdersCondition==1) {
         Write("Opening BuyStop , OrdersCondition="+OrdersCondition+" SecOfDay="+secofday);
         OpenBuyStop();
      }
   }

   if ((secofday<secofnews) && (secofday>(secofnews-SecBPO)) && (secofday<(secofnews-SecBMO))) {
         Write("Modifying Orders, OrdersCondition="+OrdersCondition+" SecOfDay="+secofday);
         DoModify();
      }
      
   if ((secofday>secofnews) && (secofday<(secofnews+STWAN)) && OCO)
   {
      if (OrdersCondition==1001)
      {
         Write("Deleting SellStop Because of BuyStop Hit, OrdersCondition="+OrdersCondition+" SecOfDay="+secofday);
         DeleteSellStop();
      }
      
      if (OrdersCondition==110)
      {
        Write("Deleting BuyStop Because of SellStop Hit, OrdersCondition="+OrdersCondition+" SecOfDay="+secofday);
        DeleteBuyStop();
      }
   }
   
   if ((secofday>secofnews) && (secofday>(secofnews+STWAN)))
   {
      if (OrdersCondition==11)
      {
         Write("Deleting BuyStop and SellStop Because 5 min expired, OrdersCondition="+OrdersCondition+" SecOfDay="+secofday);
         DeleteBuyStop();
         DeleteSellStop();
      }
      
      if ((OrdersCondition==10) || (OrdersCondition==110))
      {
        Write("Deleting BuyStop Because expired, OrdersCondition="+OrdersCondition+" SecOfDay="+secofday);
        DeleteBuyStop();
      }
      
      if ((OrdersCondition==1) || (OrdersCondition==1001))
      {
        Write("Deleting SellStop Because expired, OrdersCondition="+OrdersCondition+" SecOfDay="+secofday);
        DeleteSellStop();
      }
   }
   
   for (int j = 0; j < OrdersTotal(); j++)
   {
      OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==Symbol() && (OrderMagicNumber() == Magic) && (OrderType()==OP_BUYSTOP) && OrderOpenTime()+STWAN+300 < TimeCurrent())
      {
        OrderDelete(OrderTicket());
        Write("in function DeleteBuyStopOrderDelete Executed");
      }
      if (OrderSymbol()==Symbol() && (OrderMagicNumber() == Magic) && (OrderType()==OP_SELLSTOP) && OrderOpenTime()+STWAN+300 < TimeCurrent())
      {
         OrderDelete(OrderTicket());
         Write("in function DeleteSellStopOrderDelete Executed");
      }
   }

   return(0);
}


double LotsOptimized(double Lots)
{
   double MinLotSize=0;
   double MaxLotSize=0;
   double LotStep=0;
   MinLotSize = MarketInfo(Symbol(),MODE_MINLOT);
   MaxLotSize = MarketInfo(Symbol(),MODE_MAXLOT);
   LotStep = MarketInfo(Symbol(),MODE_LOTSTEP);  

   //---- select lot size
   if (UseMM)
   {
      Lots = NormalizeDouble(AccountFreeMargin() * RiskPercent * 0.01 / (SL * MarketInfo(Symbol(),MODE_TICKVALUE)),2);
      Lots = NormalizeDouble(Lots/LotStep,0) * LotStep;
   }
   if(Lots < MinLotSize) 
   {
      Lots = MinLotSize;
   }
   if(Lots > MaxLotSize)
   {
      Lots = MaxLotSize;
   }

   // lot at this point is number of standard lots
   return(Lots);
} 

  
int CheckOrdersCondition()
  {
    int result=0;
    for (int i = 0; i < OrdersTotal(); i++) {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if ((OrderType()==OP_BUY) && (OrderSymbol() == Symbol()) && (OrderMagicNumber() == Magic))
      {
        result=result+1000; 
      }
      if ((OrderType()==OP_SELL) && (OrderSymbol() == Symbol()) && (OrderMagicNumber() == Magic))
      {
        result=result+100; 
      }
      if ((OrderType()==OP_BUYSTOP) && (OrderSymbol() == Symbol()) && (OrderMagicNumber() == Magic))
      {
        result=result+10;
      }
      if ((OrderType()==OP_SELLSTOP) && (OrderSymbol() == Symbol()) && (OrderMagicNumber() == Magic))
      {
        result=result+1; 
      }

    }
    return(result); // 0 means we have no trades
  }
  
// OrdersCondition Result Pattern
//    1    1    1    1
//    b    s    bs   ss
//  
  
  
void OpenBuyStop()
 {
    int ticket,err,tries;
        tries = 0;
        if (!GlobalVariableCheck("InTrade"))
        {
          while (tries < 3)
            {
               GlobalVariableSet("InTrade", CurTime());  // set lock indicator
               ticket = OrderSend(Symbol(),OP_BUYSTOP,LotsOptimized(Lots),ho,1,hso,htp,"News/Opening EA",Magic,0,Red);
               Write("in function OpenBuyStop OrderSend Executed , ticket ="+ticket);
               GlobalVariableDel("InTrade");   // clear lock indicator
               if(ticket<=0) {
                  Write("Error Accured : "+ErrorDescription(GetLastError())+" BuyStop: "+ho+" SL: "+hso+" TP:"+htp);
                  tries++;
               } else tries = 3;
            }
        }
 }
  
void OpenSellStop()
 {
    int ticket,err,tries;
        tries = 0;
        if (!GlobalVariableCheck("InTrade"))
        {
          while (tries < 3)
            {
               GlobalVariableSet("InTrade", CurTime());  // set lock indicator
               ticket = OrderSend(Symbol(),OP_SELLSTOP,LotsOptimized(Lots),lo,1,lso,ltp,"News/Opening EA",Magic,0,Red);
               Write("in function OpenSellStop OrderSend Executed , ticket ="+ticket);
               GlobalVariableDel("InTrade");   // clear lock indicator
               if(ticket<=0)
               {
                  Write("Error Accured : "+ErrorDescription(GetLastError())+" BuyStop: "+lo+" SL: "+lso+" TP:"+ltp);
                  tries++;
               } else tries = 3;
            }
        }
 }
 
void DoBE(int BEPips)
{
   if(BEPips < MarketInfo(Symbol(),MODE_STOPLEVEL))
   {
      BEPips = MarketInfo(Symbol(),MODE_STOPLEVEL);
   } 

   for (int i = 0; i < OrdersTotal(); i++)
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if ( OrderSymbol()==Symbol() && (OrderMagicNumber() == Magic))  // only look if magic and symbol...
      {
         if (OrderType() == OP_BUY && Bid - OrderOpenPrice() > BEPips * Point && OrderStopLoss() < OrderOpenPrice())
         {
            Write("Moving StopLoss of Buy Order to BE+1");
            OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() +  Point, OrderTakeProfit(), Red);
         }
         if (OrderType() == OP_SELL && OrderOpenPrice() - Ask > BEPips * Point && OrderStopLoss() > OrderOpenPrice())
         { 
            Write("Moving StopLoss of Buy Order to BE+1");
            OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() -  Point, OrderTakeProfit(), Red);
         }
      }
   }
}

void DoTrail()
{
   if(TrailingStop < MarketInfo(Symbol(),MODE_STOPLEVEL))
   {
      TrailingStop = MarketInfo(Symbol(),MODE_STOPLEVEL);
   } 
   for (int i = 0; i < OrdersTotal(); i++)
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() && (OrderMagicNumber() == Magic))  // only look if magic and symbol...
      {
         if (OrderType() == OP_BUY)
         {
            if(Bid-OrderOpenPrice()>Point*TrailingStop)
            {
               if(OrderStopLoss()<Bid-Point*TrailingStop)
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                  return(0);
               }
            }
         }

         if (OrderType() == OP_SELL) 
         {
            if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
            {
               if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                  return(0);
               }
            }
         }
       }
    }
 }
 

void DeleteBuyStop()
{
   for (int i = 0; i < OrdersTotal(); i++)
   {
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
     if (OrderSymbol()==Symbol() && (OrderMagicNumber() == Magic) && (OrderType()==OP_BUYSTOP))
     {
       OrderDelete(OrderTicket());
       Write("in function DeleteBuyStopOrderDelete Executed");
     }
       
   }
}
   
void DeleteSellStop()
{
   for (int i = 0; i < OrdersTotal(); i++) {
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
     if (OrderSymbol()==Symbol() && (OrderMagicNumber() == Magic) && (OrderType()==OP_SELLSTOP))
     {
       OrderDelete(OrderTicket());
       Write("in function DeleteSellStopOrderDelete Executed");
     }
       
   }
}

void DoModify()
{
   for (int i = 0; i < OrdersTotal(); i++) {
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
     if (OrderSymbol()==Symbol() && (OrderMagicNumber() == Magic) && (OrderType()==OP_SELLSTOP))
     {
       if ((OrderOpenPrice()>lo) || (OrderOpenPrice()<lo))
       {
         Write("in function DoModify , SellStop OrderModify Executed, Sell Stop was: "+DoubleToStr(OrderOpenPrice(),4)+" it changed to "+DoubleToStr(lo,4));
         OrderModify(OrderTicket(),lo,lso,ltp,0,Red);
       }
     }

     if (OrderSymbol()==Symbol() && (OrderMagicNumber() == Magic) && (OrderType()==OP_BUYSTOP))
     {
       if ((OrderOpenPrice()>ho) || (OrderOpenPrice()<ho))
       {
         Write("in function DoModify , BuyStop OrderModify Executed, Buy Stop was: "+DoubleToStr(OrderOpenPrice(),4)+" it changed to "+DoubleToStr(ho,4));
         OrderModify(OrderTicket(),ho,hso,htp,0,Red);
       }
     }
   }
}

int Write(string str)
{
   int handle;
  
   handle = FileOpen(filename,FILE_READ|FILE_WRITE|FILE_CSV,"/t");
   FileSeek(handle, 0, SEEK_END);      
   FileWrite(handle,str + " Time " + TimeToStr(CurTime(),TIME_DATE|TIME_SECONDS));
   FileClose(handle);
}



string News_file(int NTrigger)
{
   int Handle,                         // File descriptor
       Stl;                            // Style of vertical line
   string File_Name="News.csv",        // Name of the file
          Obj_Name,                    // Name of the object
          Instr,                       // Name of the currency
          One,Two,                     // 1st and 2nd name of the instr.
          Text,                        // Text of event description
          Str_DtTm;                    // Date and time of the event (line)
   datetime Dat_DtTm;                  // Date and time of the event (date)
   color Col;                          // Color of the vertical line
//--------------------------------------------------------------- 3 --
   Handle=FileOpen(File_Name,FILE_CSV|FILE_READ,";");// File opening
   if(Handle<0)                        // File opening fails
   {
      if(GetLastError()==4103)         // If the file does not exist,..
         Alert("No file named ",File_Name);//.. inform trader
      else                             // If any other error occurs..
         Alert("Error while opening file ",File_Name);//..this message
      return (0);                          // Exit start()      
   }
//--------------------------------------------------------------- 4 --
   while(FileIsEnding(Handle)==false)  // While the file pointer..
   {                                 // ..is not at the end of the file
      //--------------------------------------------------------- 5 --
      Str_DtTm =FileReadString(Handle);// Date and time of the event (date)
      Text     =FileReadString(Handle);// Text of event description
      if(FileIsEnding(Handle)==true)   // File pointer is at the end
         break;                        // Exit reading and drawing
      //--------------------------------------------------------- 6 --
      Dat_DtTm =StrToTime(Str_DtTm);   // Transformation of data type
      TME=Dat_DtTm+GMT_Offset*3600;
      if(Dat_DtTm+GMT_Offset*3600+6*60 > TimeCurrent())
      {
         if(NTrigger != -1)
         {
            NDay = TimeDay(Dat_DtTm);
            NHour = TimeHour(Dat_DtTm) + GMT_Offset;
            NMin = TimeMinute(Dat_DtTm);
         }
         break;
      }
      if(GMT_Offset > 0 && NHour + GMT_Offset > 24)
      {
         NDay = NDay + 1;
         NHour = NHour - 24;
      }
      if(GMT_Offset < 0 && NHour < 0)
      {
         NDay = NDay - 1;
         NHour = NHour + 24;
      }
      
      Instr    =StringSubstr(Text,1,3);// Extract first three symbols
      One=StringSubstr(Symbol(),0,3);// Extract first three symbols
      Two=StringSubstr(Symbol(),3,3);// Extract second three symbols
      Stl=STYLE_DOT;                   // For all - dotted line style
      Col=DarkOrange;                  // For all - this color
      if(Instr==One || Instr==Two)     // And for the events of our..
      {                              // .. symbol..
         Stl=STYLE_SOLID;              // .. this style..
         Col=Red;                      // .. and this color of the vert. line
      }
      //--------------------------------------------------------- 7 --
      Obj_Name="News_Line  "+Str_DtTm+" GMT";              // Name of the object
      ObjectCreate(Obj_Name,OBJ_VLINE,0,Dat_DtTm,0);// Create object..
      ObjectSet(Obj_Name,OBJPROP_COLOR, Col);       // ..and its color,..
      ObjectSet(Obj_Name,OBJPROP_STYLE, Stl);       // ..and style..
      ObjectSetText(Obj_Name,Text,10);              // ..and description
   }
//--------------------------------------------------------------- 8 --
   FileClose(Handle);                // Close file
   return(Text);
}
//+------------------------------------------------------------------+
//| return error description                                         |
//+------------------------------------------------------------------+
string ErrorDescription(int error_code)
{
   string error_string;
//----
   switch(error_code)
   {
      //---- codes returned from trade server
      case 0:
      case 1:   error_string="no error";                                                  break;
      case 2:   error_string="common error";                                              break;
      case 3:   error_string="invalid trade parameters";                                  break;
      case 4:   error_string="trade server is busy";                                      break;
      case 5:   error_string="old version of the client terminal";                        break;
      case 6:   error_string="no connection with trade server";                           break;
      case 7:   error_string="not enough rights";                                         break;
      case 8:   error_string="too frequent requests";                                     break;
      case 9:   error_string="malfunctional trade operation";                             break;
      case 64:  error_string="account disabled";                                          break;
      case 65:  error_string="invalid account";                                           break;
      case 128: error_string="trade timeout";                                             break;
      case 129: error_string="invalid price";                                             break;
      case 130: error_string="invalid stops";                                             break;
      case 131: error_string="invalid trade volume";                                      break;
      case 132: error_string="market is closed";                                          break;
      case 133: error_string="trade is disabled";                                         break;
      case 134: error_string="not enough money";                                          break;
      case 135: error_string="price changed";                                             break;
      case 136: error_string="off quotes";                                                break;
      case 137: error_string="broker is busy";                                            break;
      case 138: error_string="requote";                                                   break;
      case 139: error_string="order is locked";                                           break;
      case 140: error_string="long positions only allowed";                               break;
      case 141: error_string="too many requests";                                         break;
      case 145: error_string="modification denied because order too close to market";     break;
      case 146: error_string="trade context is busy";                                     break;
      //---- mql4 errors
      case 4000: error_string="no error";                                                 break;
      case 4001: error_string="wrong function pointer";                                   break;
      case 4002: error_string="array index is out of range";                              break;
      case 4003: error_string="no memory for function call stack";                        break;
      case 4004: error_string="recursive stack overflow";                                 break;
      case 4005: error_string="not enough stack for parameter";                           break;
      case 4006: error_string="no memory for parameter string";                           break;
      case 4007: error_string="no memory for temp string";                                break;
      case 4008: error_string="not initialized string";                                   break;
      case 4009: error_string="not initialized string in array";                          break;
      case 4010: error_string="no memory for array\' string";                             break;
      case 4011: error_string="too long string";                                          break;
      case 4012: error_string="remainder from zero divide";                               break;
      case 4013: error_string="zero divide";                                              break;
      case 4014: error_string="unknown command";                                          break;
      case 4015: error_string="wrong jump (never generated error)";                       break;
      case 4016: error_string="not initialized array";                                    break;
      case 4017: error_string="dll calls are not allowed";                                break;
      case 4018: error_string="cannot load library";                                      break;
      case 4019: error_string="cannot call function";                                     break;
      case 4020: error_string="expert function calls are not allowed";                    break;
      case 4021: error_string="not enough memory for temp string returned from function"; break;
      case 4022: error_string="system is busy (never generated error)";                   break;
      case 4050: error_string="invalid function parameters count";                        break;
      case 4051: error_string="invalid function parameter value";                         break;
      case 4052: error_string="string function internal error";                           break;
      case 4053: error_string="some array error";                                         break;
      case 4054: error_string="incorrect series array using";                             break;
      case 4055: error_string="custom indicator error";                                   break;
      case 4056: error_string="arrays are incompatible";                                  break;
      case 4057: error_string="global variables processing error";                        break;
      case 4058: error_string="global variable not found";                                break;
      case 4059: error_string="function is not allowed in testing mode";                  break;
      case 4060: error_string="function is not confirmed";                                break;
      case 4061: error_string="send mail error";                                          break;
      case 4062: error_string="string parameter expected";                                break;
      case 4063: error_string="integer parameter expected";                               break;
      case 4064: error_string="double parameter expected";                                break;
      case 4065: error_string="array as parameter expected";                              break;
      case 4066: error_string="requested history data in update state";                   break;
      case 4099: error_string="end of file";                                              break;
      case 4100: error_string="some file error";                                          break;
      case 4101: error_string="wrong file name";                                          break;
      case 4102: error_string="too many opened files";                                    break;
      case 4103: error_string="cannot open file";                                         break;
      case 4104: error_string="incompatible access to a file";                            break;
      case 4105: error_string="no order selected";                                        break;
      case 4106: error_string="unknown symbol";                                           break;
      case 4107: error_string="invalid price parameter for trade function";               break;
      case 4108: error_string="invalid ticket";                                           break;
      case 4109: error_string="trade is not allowed";                                     break;
      case 4110: error_string="longs are not allowed";                                    break;
      case 4111: error_string="shorts are not allowed";                                   break;
      case 4200: error_string="object does already exist";                                break;
      case 4201: error_string="unknown object property";                                  break;
      case 4202: error_string="object does not exist";                                    break;
      case 4203: error_string="unknown object type";                                      break;
      case 4204: error_string="no object name";                                           break;
      case 4205: error_string="object coordinates error";                                 break;
      case 4206: error_string="no specified subwindow";                                   break;
      default:   error_string="unknown error";
   }
//----
   return(error_string);
}  
//+------------------------------------------------------------------+